import { ReactInstance } from 'react';
import { Asset } from '@alilc/lowcode-utils';
import { NodeSchema } from '@alilc/lowcode-types';
import { BuiltinSimulatorRenderer, NodeInstance, Component, DocumentModel, Node } from '@alilc/lowcode-designer';
import { MemoryHistory } from 'history';
export declare class DocumentInstance {
    readonly container: SimulatorRendererContainer;
    readonly document: DocumentModel;
    instancesMap: Map<string, ReactInstance[]>;
    get schema(): any;
    private disposeFunctions;
    constructor(container: SimulatorRendererContainer, document: DocumentModel);
    private _components;
    get components(): object;
    /**
     * 本次的变更数据
     */
    private _deltaData;
    get deltaData(): any;
    /**
     * 是否使用增量模式
     */
    private _deltaMode;
    get deltaMode(): boolean;
    private _appContext;
    get context(): any;
    private _designMode;
    get designMode(): any;
    private _requestHandlersMap;
    get requestHandlersMap(): any;
    private _device;
    get device(): string;
    private _componentsMap;
    get componentsMap(): any;
    readonly suspended = false;
    readonly scope: any;
    get path(): string;
    get id(): string;
    private unmountIntance;
    mountInstance(id: string, instance: ReactInstance | null): void;
    mountContext(docId: string, id: string, ctx: object): void;
    getNode(id: string): Node | null;
    dispose(): void;
}
export declare class SimulatorRendererContainer implements BuiltinSimulatorRenderer {
    readonly isSimulatorRenderer = true;
    private disposeFunctions;
    readonly history: MemoryHistory;
    private _documentInstances;
    get documentInstances(): DocumentInstance[];
    constructor();
    private _layout;
    get layout(): any;
    set layout(value: any);
    private _libraryMap;
    private buildComponents;
    private _components;
    get components(): object;
    private _appContext;
    get context(): any;
    private _designMode;
    get designMode(): any;
    private _device;
    get device(): string;
    private _locale;
    get locale(): string;
    private _componentsMap;
    get componentsMap(): any;
    /**
     * 是否为画布自动渲染
     */
    autoRender: boolean;
    /**
     * 加载资源
     */
    load(asset: Asset): Promise<any>;
    loadAsyncLibrary(asyncLibraryMap: Record<string, any>): Promise<void>;
    getComponent(componentName: string): any;
    getClosestNodeInstance(from: ReactInstance, nodeId?: string): NodeInstance<ReactInstance> | null;
    findDOMNodes(instance: ReactInstance): Array<Element | Text> | null;
    getClientRects(element: Element | Text): DOMRect[];
    setNativeSelection(enableFlag: boolean): void;
    setDraggingState(state: boolean): void;
    setCopyState(state: boolean): void;
    clearState(): void;
    createComponent(schema: NodeSchema): Component | null;
    private _running;
    run(): void;
    /**
     * 刷新渲染器
     */
    rerender(): void;
    dispose(): void;
}
declare const _default: SimulatorRendererContainer;
export default _default;
