import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _initializerDefineProperty from "@babel/runtime/helpers/initializerDefineProperty";
import _createClass from "@babel/runtime/helpers/createClass";
import _applyDecoratedDescriptor from "@babel/runtime/helpers/applyDecoratedDescriptor";
import _initializerWarningHelper from "@babel/runtime/helpers/initializerWarningHelper";
var _excluded = ["__id", "__designMode"];

var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _class3, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15;

import _regeneratorRuntime from "@babel/runtime/regenerator";
import React from 'react';
import { render as reactRender } from 'react-dom';
import { host } from './host';
import SimulatorRendererView from './renderer-view';
import { computed, observable as obx, untracked, makeObservable, configure } from 'mobx';
import { getClientRects as _getClientRects } from './utils/get-client-rects';
import { reactFindDOMNodes, FIBER_KEY } from './utils/react-find-dom-nodes';
import { isElement, cursor, setNativeSelection as _setNativeSelection, getSubComponent, compatibleLegaoSchema, isPlainObject, AssetLoader, getProjectUtils } from '@alilc/lowcode-utils';
import { TransformStage } from '@alilc/lowcode-types'; // just use types

import LowCodeRenderer, { buildComponents as _buildComponents, createElement } from '@lowcodecloud/lowcode-engine-vue2-renderer';
import { createMemoryHistory } from 'history';
import Slot from './builtin-components/slot';
import Leaf from './builtin-components/leaf';
import { withQueryParams, parseQuery } from './utils/url';
import { merge } from 'lodash';
var loader = new AssetLoader();
configure({
  enforceActions: 'never'
});
export var DocumentInstance = (_dec = obx.ref, _dec2 = obx.ref, _dec3 = obx.ref, _dec4 = obx.ref, _dec5 = obx.ref, _dec6 = obx.ref, _dec7 = obx.ref, _dec8 = obx.ref, (_class = /*#__PURE__*/function () {
  function DocumentInstance(container, document) {
    this.container = container;
    this.document = document;
    this.instancesMap = new Map();
    this.disposeFunctions = [];

    _initializerDefineProperty(this, "_components", _descriptor, this);

    _initializerDefineProperty(this, "_deltaData", _descriptor2, this);

    _initializerDefineProperty(this, "_deltaMode", _descriptor3, this);

    _initializerDefineProperty(this, "_appContext", _descriptor4, this);

    _initializerDefineProperty(this, "_designMode", _descriptor5, this);

    _initializerDefineProperty(this, "_requestHandlersMap", _descriptor6, this);

    _initializerDefineProperty(this, "_device", _descriptor7, this);

    _initializerDefineProperty(this, "_componentsMap", _descriptor8, this);

    this.suspended = false;
    this.scope = null;
    makeObservable(this);
  }

  var _proto = DocumentInstance.prototype;

  _proto.unmountIntance = function unmountIntance(id, instance) {
    var instances = this.instancesMap.get(id);

    if (instances) {
      var i = instances.indexOf(instance);

      if (i > -1) {
        instances.splice(i, 1);
        host.setInstance(this.document.id, id, instances);
      }
    }
  };

  _proto.mountInstance = function mountInstance(id, instance) {
    var docId = this.document.id;
    var instancesMap = this.instancesMap;

    if (instance == null) {
      var _instances = this.instancesMap.get(id);

      if (_instances) {
        _instances = _instances.filter(checkInstanceMounted);

        if (_instances.length > 0) {
          instancesMap.set(id, _instances);
          host.setInstance(this.document.id, id, _instances);
        } else {
          instancesMap["delete"](id);
          host.setInstance(this.document.id, id, null);
        }
      }

      return;
    }

    var unmountIntance = this.unmountIntance.bind(this);
    var origId = instance[SYMBOL_VNID];

    if (origId && origId !== id) {
      // 另外一个节点的 instance 在此被复用了，需要从原来地方卸载
      unmountIntance(origId, instance);
    }

    if (isElement(instance)) {
      cacheReactKey(instance);
    } else if (origId !== id) {
      // 涵盖 origId == null || origId !== id 的情况
      var origUnmount = instance.componentWillUnmount;

      if (origUnmount && origUnmount.origUnmount) {
        origUnmount = origUnmount.origUnmount;
      } // hack! delete instance from map


      var newUnmount = function newUnmount() {
        unmountIntance(id, instance);
        origUnmount && origUnmount.call(this);
      };

      newUnmount.origUnmount = origUnmount;
      instance.componentWillUnmount = newUnmount;
    }

    instance[SYMBOL_VNID] = id;
    instance[SYMBOL_VDID] = docId;
    var instances = this.instancesMap.get(id);

    if (instances) {
      var l = instances.length;
      instances = instances.filter(checkInstanceMounted);
      var updated = instances.length !== l;

      if (!instances.includes(instance)) {
        instances.push(instance);
        updated = true;
      }

      if (!updated) {
        return;
      }
    } else {
      instances = [instance];
    }

    instancesMap.set(id, instances);
    host.setInstance(this.document.id, id, instances);
  };

  _proto.mountContext = function mountContext(docId, id, ctx) {// this.ctxMap.set(id, ctx);
  };

  _proto.getNode = function getNode(id) {
    return this.document.getNode(id);
  };

  _proto.dispose = function dispose() {
    this.disposeFunctions.forEach(function (fn) {
      return fn();
    });
    this.instancesMap = new Map();
  };

  _createClass(DocumentInstance, [{
    key: "schema",
    get: function get() {
      return this.document["export"](TransformStage.Render);
    }
  }, {
    key: "components",
    get: function get() {
      // 根据 device 选择不同组件，进行响应式
      // 更好的做法是，根据 device 选择加载不同的组件资源，甚至是 simulatorUrl
      return this._components;
    }
    /**
     * 本次的变更数据
     */

  }, {
    key: "deltaData",
    get: function get() {
      return this._deltaData;
    }
    /**
     * 是否使用增量模式
     */

  }, {
    key: "deltaMode",
    get: function get() {
      return this._deltaMode;
    } // context from: utils、constants、history、location、match

  }, {
    key: "context",
    get: function get() {
      return this._appContext;
    }
  }, {
    key: "designMode",
    get: function get() {
      return this._designMode;
    }
  }, {
    key: "requestHandlersMap",
    get: function get() {
      return this._requestHandlersMap;
    }
  }, {
    key: "device",
    get: function get() {
      return this._device;
    }
  }, {
    key: "componentsMap",
    get: function get() {
      return this._componentsMap;
    }
  }, {
    key: "path",
    get: function get() {
      return "/" + this.document.fileName;
    }
  }, {
    key: "id",
    get: function get() {
      return this.document.id;
    }
  }]);

  return DocumentInstance;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, "_components", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return {};
  }
}), _applyDecoratedDescriptor(_class.prototype, "components", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "components"), _class.prototype), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, "_deltaData", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return {};
  }
}), _applyDecoratedDescriptor(_class.prototype, "deltaData", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "deltaData"), _class.prototype), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, "_deltaMode", [_dec3], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _applyDecoratedDescriptor(_class.prototype, "deltaMode", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "deltaMode"), _class.prototype), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, "_appContext", [_dec4], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return {};
  }
}), _applyDecoratedDescriptor(_class.prototype, "context", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "context"), _class.prototype), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, "_designMode", [_dec5], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return 'design';
  }
}), _applyDecoratedDescriptor(_class.prototype, "designMode", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "designMode"), _class.prototype), _descriptor6 = _applyDecoratedDescriptor(_class.prototype, "_requestHandlersMap", [_dec6], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return null;
  }
}), _applyDecoratedDescriptor(_class.prototype, "requestHandlersMap", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "requestHandlersMap"), _class.prototype), _descriptor7 = _applyDecoratedDescriptor(_class.prototype, "_device", [_dec7], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return 'default';
  }
}), _applyDecoratedDescriptor(_class.prototype, "device", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "device"), _class.prototype), _descriptor8 = _applyDecoratedDescriptor(_class.prototype, "_componentsMap", [_dec8], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return {};
  }
}), _applyDecoratedDescriptor(_class.prototype, "componentsMap", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "componentsMap"), _class.prototype)), _class));
export var SimulatorRendererContainer = (_dec9 = obx.ref, _dec10 = obx.ref, _dec11 = obx.ref, _dec12 = obx.ref, _dec13 = obx.ref, _dec14 = obx.ref, (_class3 = /*#__PURE__*/function () {
  function SimulatorRendererContainer() {
    var _this = this;

    this.isSimulatorRenderer = true;
    this.disposeFunctions = [];
    this.history = void 0;

    _initializerDefineProperty(this, "_documentInstances", _descriptor9, this);

    _initializerDefineProperty(this, "_layout", _descriptor10, this);

    this._libraryMap = {};
    this._components = {};

    _initializerDefineProperty(this, "_appContext", _descriptor11, this);

    _initializerDefineProperty(this, "_designMode", _descriptor12, this);

    _initializerDefineProperty(this, "_device", _descriptor13, this);

    _initializerDefineProperty(this, "_locale", _descriptor14, this);

    _initializerDefineProperty(this, "_componentsMap", _descriptor15, this);

    this.autoRender = true;
    this._running = false;
    makeObservable(this);
    this.autoRender = host.autoRender;
    this.disposeFunctions.push(host.connect(this, function () {
      // sync layout config
      _this._layout = host.project.get('config').layout; // todo: split with others, not all should recompute

      if (_this._libraryMap !== host.libraryMap || _this._componentsMap !== host.designer.componentsMap) {
        _this._libraryMap = host.libraryMap || {};
        _this._componentsMap = host.designer.componentsMap;

        _this.buildComponents();
      } // sync designMode


      _this._designMode = host.designMode;
      _this._locale = host.locale; // sync requestHandlersMap
      // @ts-ignore

      _this._requestHandlersMap = host.requestHandlersMap; // sync device

      _this._device = host.device;
    }));
    var documentInstanceMap = new Map();
    var initialEntry = '/';
    var firstRun = true;
    this.disposeFunctions.push(host.autorun(function () {
      _this._documentInstances = host.project.documents.map(function (doc) {
        var inst = documentInstanceMap.get(doc.id);

        if (!inst) {
          inst = new DocumentInstance(_this, doc);
          documentInstanceMap.set(doc.id, inst);
        }

        return inst;
      });
      var path = host.project.currentDocument ? documentInstanceMap.get(host.project.currentDocument.id).path : '/';

      if (firstRun) {
        initialEntry = path;
        firstRun = false;
      } else if (_this.history.location.pathname !== path) {
        _this.history.replace(path);
      }
    }));
    var history = createMemoryHistory({
      initialEntries: [initialEntry]
    });
    this.history = history; // @ts-ignore

    history.listen(function (location, action) {
      var docId = location.pathname.slice(1);
      docId && host.project.open(docId);
    });
    host.componentsConsumer.consume( /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(componentsAsset) {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!componentsAsset) {
                  _context.next = 4;
                  break;
                }

                _context.next = 3;
                return _this.load(componentsAsset);

              case 3:
                _this.buildComponents();

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    this._appContext = {
      utils: _extends({
        router: {
          push: function push(path, params) {
            history.push(withQueryParams(path, params));
          },
          replace: function replace(path, params) {
            history.replace(withQueryParams(path, params));
          }
        },
        legaoBuiltins: {
          getUrlParams: function getUrlParams() {
            var search = history.location.search;
            return parseQuery(search);
          }
        },
        i18n: {
          setLocale: function setLocale(loc) {
            _this._appContext.utils.i18n.currentLocale = loc;
            _this._locale = loc;
          },
          currentLocale: this.locale,
          messages: {}
        }
      }, getProjectUtils(this._libraryMap, host.get('utilsMetadata'))),
      constants: {},
      // @ts-ignore
      requestHandlersMap: this._requestHandlersMap
    };
    host.injectionConsumer.consume(function (data) {
      // TODO: sync utils, i18n, contants,... config
      var newCtx = _extends({}, _this._appContext);

      newCtx.utils.i18n.messages = data.i18n || {};
      merge(newCtx, data.appHelper || {});
      _this._appContext = newCtx;
    });
  }

  var _proto2 = SimulatorRendererContainer.prototype;

  _proto2.buildComponents = function buildComponents() {
    this._components = _buildComponents(this._libraryMap, this._componentsMap, this.createComponent.bind(this));
    this._components = _extends({}, builtinComponents, this._components);
  };

  /**
   * 加载资源
   */
  _proto2.load = function load(asset) {
    return loader.load(asset);
  };

  _proto2.loadAsyncLibrary = /*#__PURE__*/function () {
    var _loadAsyncLibrary = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(asyncLibraryMap) {
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return loader.loadAsyncLibrary(asyncLibraryMap);

            case 2:
              this.buildComponents();

            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function loadAsyncLibrary(_x2) {
      return _loadAsyncLibrary.apply(this, arguments);
    }

    return loadAsyncLibrary;
  }();

  _proto2.getComponent = function getComponent(componentName) {
    var paths = componentName.split('.');
    var subs = [];

    while (true) {
      var component = this._components[componentName];

      if (component) {
        return getSubComponent(component, subs);
      }

      var sub = paths.pop();

      if (!sub) {
        return null;
      }

      subs.unshift(sub);
      componentName = paths.join('.');
    }
  };

  _proto2.getClosestNodeInstance = function getClosestNodeInstance(from, nodeId) {
    return _getClosestNodeInstance(from, nodeId);
  };

  _proto2.findDOMNodes = function findDOMNodes(instance) {
    return reactFindDOMNodes(instance);
  };

  _proto2.getClientRects = function getClientRects(element) {
    return _getClientRects(element);
  };

  _proto2.setNativeSelection = function setNativeSelection(enableFlag) {
    _setNativeSelection(enableFlag);
  };

  _proto2.setDraggingState = function setDraggingState(state) {
    cursor.setDragging(state);
  };

  _proto2.setCopyState = function setCopyState(state) {
    cursor.setCopy(state);
  };

  _proto2.clearState = function clearState() {
    cursor.release();
  };

  _proto2.createComponent = function createComponent(schema) {
    var _schema = _extends({}, compatibleLegaoSchema(schema));

    if (schema.componentName === 'Component' && schema.css) {
      var doc = window.document;
      var s = doc.createElement('style');
      s.setAttribute('type', 'text/css');
      s.setAttribute('id', "Component-" + (schema.id || ''));
      s.appendChild(doc.createTextNode(schema.css || ''));
      doc.getElementsByTagName('head')[0].appendChild(s);
    }

    var renderer = this;

    var LowCodeComp = /*#__PURE__*/function (_React$Component) {
      _inheritsLoose(LowCodeComp, _React$Component);

      function LowCodeComp() {
        return _React$Component.apply(this, arguments) || this;
      }

      var _proto3 = LowCodeComp.prototype;

      _proto3.render = function render() {
        var extraProps = getLowCodeComponentProps(this.props);
        return createElement(LowCodeRenderer, _extends({}, extraProps, {
          // 防止覆盖下面内置属性
          // 使用 _schema 为了使低代码组件在页面设计中使用变量，同 react 组件使用效果一致
          schema: _schema,
          components: renderer.components,
          designMode: renderer.designMode,
          device: renderer.device,
          appHelper: renderer.context,
          rendererName: 'LowCodeRenderer',
          customCreateElement: function customCreateElement(Comp, props, children) {
            var _host$currentDocument;

            var componentMeta = (_host$currentDocument = host.currentDocument) === null || _host$currentDocument === void 0 ? void 0 : _host$currentDocument.getComponentMeta(Comp.displayName);

            if (componentMeta !== null && componentMeta !== void 0 && componentMeta.isModal) {
              return null;
            }

            var __id = props.__id,
                __designMode = props.__designMode,
                viewProps = _objectWithoutPropertiesLoose(props, _excluded); // mock _leaf，减少性能开销


            var _leaf = {
              isEmpty: function isEmpty() {
                return false;
              }
            };
            viewProps._leaf = _leaf;
            return createElement(Comp, viewProps, children);
          }
        }));
      };

      return LowCodeComp;
    }(React.Component);

    return LowCodeComp;
  };

  _proto2.run = function run() {
    if (this._running) {
      return;
    }

    this._running = true;
    var containerId = 'app';
    var container = document.getElementById(containerId);

    if (!container) {
      container = document.createElement('div');
      document.body.appendChild(container);
      container.id = containerId;
    } // ==== compatible vision


    document.documentElement.classList.add('engine-page');
    document.body.classList.add('engine-document'); // important! Stylesheet.invoke depends

    reactRender(createElement(SimulatorRendererView, {
      rendererContainer: this
    }), container);
    host.project.setRendererReady(this);
  }
  /**
   * 刷新渲染器
   */
  ;

  _proto2.rerender = function rerender() {
    this.autoRender = true; // TODO: 不太优雅

    this._appContext = _extends({}, this._appContext);
  };

  _proto2.dispose = function dispose() {
    var _this2 = this;

    this.disposeFunctions.forEach(function (fn) {
      return fn();
    });
    this.documentInstances.forEach(function (docInst) {
      return docInst.dispose();
    });
    untracked(function () {
      _this2._componentsMap = {};
      _this2._components = null;
      _this2._appContext = null;
    });
  };

  _createClass(SimulatorRendererContainer, [{
    key: "documentInstances",
    get: function get() {
      return this._documentInstances;
    }
  }, {
    key: "layout",
    get: function get() {
      // TODO: parse layout Component
      return this._layout;
    },
    set: function set(value) {
      this._layout = value;
    }
  }, {
    key: "components",
    get: function get() {
      // 根据 device 选择不同组件，进行响应式
      // 更好的做法是，根据 device 选择加载不同的组件资源，甚至是 simulatorUrl
      return this._components;
    } // context from: utils、constants、history、location、match

  }, {
    key: "context",
    get: function get() {
      return this._appContext;
    }
  }, {
    key: "designMode",
    get: function get() {
      return this._designMode;
    }
  }, {
    key: "device",
    get: function get() {
      return this._device;
    }
  }, {
    key: "locale",
    get: function get() {
      return this._locale;
    }
  }, {
    key: "componentsMap",
    get: function get() {
      return this._componentsMap;
    }
    /**
     * 是否为画布自动渲染
     */

  }]);

  return SimulatorRendererContainer;
}(), (_descriptor9 = _applyDecoratedDescriptor(_class3.prototype, "_documentInstances", [_dec9], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor10 = _applyDecoratedDescriptor(_class3.prototype, "_layout", [obx], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return null;
  }
}), _applyDecoratedDescriptor(_class3.prototype, "layout", [computed], Object.getOwnPropertyDescriptor(_class3.prototype, "layout"), _class3.prototype), _descriptor11 = _applyDecoratedDescriptor(_class3.prototype, "_appContext", [_dec10], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return {};
  }
}), _applyDecoratedDescriptor(_class3.prototype, "context", [computed], Object.getOwnPropertyDescriptor(_class3.prototype, "context"), _class3.prototype), _descriptor12 = _applyDecoratedDescriptor(_class3.prototype, "_designMode", [_dec11], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return 'design';
  }
}), _applyDecoratedDescriptor(_class3.prototype, "designMode", [computed], Object.getOwnPropertyDescriptor(_class3.prototype, "designMode"), _class3.prototype), _descriptor13 = _applyDecoratedDescriptor(_class3.prototype, "_device", [_dec12], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return 'default';
  }
}), _applyDecoratedDescriptor(_class3.prototype, "device", [computed], Object.getOwnPropertyDescriptor(_class3.prototype, "device"), _class3.prototype), _descriptor14 = _applyDecoratedDescriptor(_class3.prototype, "_locale", [_dec13], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return undefined;
  }
}), _applyDecoratedDescriptor(_class3.prototype, "locale", [computed], Object.getOwnPropertyDescriptor(_class3.prototype, "locale"), _class3.prototype), _descriptor15 = _applyDecoratedDescriptor(_class3.prototype, "_componentsMap", [_dec14], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return {};
  }
}), _applyDecoratedDescriptor(_class3.prototype, "componentsMap", [computed], Object.getOwnPropertyDescriptor(_class3.prototype, "componentsMap"), _class3.prototype)), _class3)); // Slot/Leaf and Fragment|FunctionComponent polyfill(ref)

var builtinComponents = {
  Slot: Slot,
  Leaf: Leaf
};
var REACT_KEY = '';

function cacheReactKey(el) {
  if (REACT_KEY !== '') {
    return el;
  } // react17 采用 __reactFiber 开头


  REACT_KEY = Object.keys(el).find(function (key) {
    return key.startsWith('__reactInternalInstance$') || key.startsWith('__reactFiber$');
  }) || '';

  if (!REACT_KEY && el.parentElement) {
    return cacheReactKey(el.parentElement);
  }

  return el;
}

var SYMBOL_VNID = Symbol('_LCNodeId');
var SYMBOL_VDID = Symbol('_LCDocId');

function _getClosestNodeInstance(from, specId) {
  var el = from;

  if (el) {
    if (isElement(el)) {
      el = cacheReactKey(el);
    } else {
      return getNodeInstance(el[FIBER_KEY], specId);
    }
  }

  while (el) {
    if (SYMBOL_VNID in el) {
      var nodeId = el[SYMBOL_VNID];
      var docId = el[SYMBOL_VDID];

      if (!specId || specId === nodeId) {
        return {
          docId: docId,
          nodeId: nodeId,
          instance: el
        };
      }
    } // get fiberNode from element


    if (el[REACT_KEY]) {
      return getNodeInstance(el[REACT_KEY], specId);
    }

    el = el.parentElement;
  }

  return null;
}

function getNodeInstance(fiberNode, specId) {
  var instance = fiberNode === null || fiberNode === void 0 ? void 0 : fiberNode.stateNode;

  if (instance && SYMBOL_VNID in instance) {
    var nodeId = instance[SYMBOL_VNID];
    var docId = instance[SYMBOL_VDID];

    if (!specId || specId === nodeId) {
      return {
        docId: docId,
        nodeId: nodeId,
        instance: instance
      };
    }
  }

  if (!instance && !(fiberNode !== null && fiberNode !== void 0 && fiberNode["return"])) return null;
  return getNodeInstance(fiberNode === null || fiberNode === void 0 ? void 0 : fiberNode["return"]);
}

function checkInstanceMounted(instance) {
  if (isElement(instance)) {
    return instance.parentElement != null;
  }

  return true;
}

function getLowCodeComponentProps(props) {
  if (!props || !isPlainObject(props)) {
    return props;
  }

  var newProps = {};
  Object.keys(props).forEach(function (k) {
    if (['children', 'componentId', '__designMode', '_componentName', '_leaf'].includes(k)) {
      return;
    }

    newProps[k] = props[k];
  });
  return newProps;
}

export default new SimulatorRendererContainer();